﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Ruru.Game
{
    public class AntQuiz
    {
        /// <summary>
        /// 맨 앞에 문자와 같은 문자가 연속적으로 몇번 나오는가
        /// </summary>
        /// <param name="cc">입력 문자배열</param>
        public int Many(char[] cc)
        {
            int count = 1;

            for (int i = 1; i < cc.Length; i++)
                if (cc[0] == cc[i])
                    count++;
                else
                    break;

            return count;
        }

        /// <summary>
        /// 다음 문자열
        /// 1121 --> NextString(2) --> "21"
        /// </summary>
        /// <param name="nstr"></param>
        /// <returns></returns>
        public string NextString(string nstr)
        {
            string ns = string.Empty;
            ns = nstr.Substring(this.Many(nstr.ToCharArray()));
            return ns;
        }

        /// <summary>
        /// 이전 문자열
        /// 1121 --> 0,2 --> 11을 리턴
        /// </summary>
        /// <param name="pstr"></param>
        /// <returns></returns>
        public string PreString(string pstr)
        {
            string ns = string.Empty;
            ns = pstr.Substring(0, this.Many(pstr.ToCharArray()));
            return ns;
        }

        /// <summary>
        /// 1121 --> 12
        /// </summary>
        /// <param name="nstr"></param>
        /// <returns></returns>
        public string MakeAnt(string nstr)
        {
            int count = this.Many(nstr.ToCharArray());
            string ns = nstr[0].ToString() + count.ToString();
            return ns;
        }

        /// <summary>
        /// 1121 --> 122111
        /// </summary>
        /// <param name="nstr"></param>
        /// <returns></returns>
        public string Make(string nstr)
        {
            string ns = string.Empty;
            string temp = nstr;
            for (int i = 0; i < temp.Length; )
            {
                ns += MakeAnt(nstr);
                i += Many(nstr.ToCharArray());
                nstr = this.NextString(nstr);
            }
            return ns;
        }

        /// <summary>
        /// 개미 실제로 출력하는 구문
        /// </summary>
        /// <param name="stairs"></param>
        public void AntStair(int stairs)
        {
            string start = "11";
            Console.WriteLine("{0}", start);

            for (int i = 0; i < stairs; i++)
                Console.WriteLine("{0}", start = Make(start));
        }

        /// <summary>
        /// 개미 실제로 출력하는 구문
        /// </summary>
        /// <param name="stairs"></param>
        public void AntStair(int stairs, string start)
        {
            Console.WriteLine("{0}", start);

            for (int i = 0; i < stairs; i++)
                Console.WriteLine("{0}", start = Make(start));
        }
    }
}
